package com.bergerkiller.bukkit.nolagg.monitor;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import com.bergerkiller.bukkit.common.permissions.NoPermissionException;
import com.bergerkiller.bukkit.nolagg.base.CommandHandler;

public class Commands extends CommandHandler {

	@Override
	public boolean handle(CommandSender sender, String[] args) throws NoPermissionException {
		if (args.length != 0) {
			if (args[0].equalsIgnoreCase("monitor") || args[0].equalsIgnoreCase("stat") || args[0].equalsIgnoreCase("stats")) {
				boolean once = !args[0].equalsIgnoreCase("monitor");
				if (sender instanceof Player) {
					Permission.MONITOR.handle(sender);
					Player p = (Player) sender;
					if (PerformanceMonitor.recipients.remove(p.getName())) {
						for (int i = 0; i < 10; i++) {
							p.sendMessage(" ");
						}
						p.sendMessage(ChatColor.YELLOW + "You are no longer monitoring this server.");
					} else {
						PerformanceMonitor.recipients.add(p.getName());
						if (once) {
							p.sendMessage(ChatColor.GREEN + "You will receive a snapshot shortly...");
							PerformanceMonitor.removalReq.add(p.getName());
						} else {
							p.sendMessage(ChatColor.GREEN + "You are now monitoring this server.");
							p.sendMessage(ChatColor.GREEN + "To stop monitoring, perform this command again.");
							PerformanceMonitor.removalReq.remove(p.getName());
						}
					}
				} else {
					if (PerformanceMonitor.sendConsole) {
						PerformanceMonitor.sendConsole = false;
						sender.sendMessage("You are no longer monitoring this server.");
					} else {
						PerformanceMonitor.sendConsole = true;
						if (once) {
							sender.sendMessage("You will receive a snapshot shortly...");
							PerformanceMonitor.removalCon = true;
						} else {
							sender.sendMessage("You are now monitoring this server.");
							sender.sendMessage("To stop monitoring, perform this command again.");
							PerformanceMonitor.removalCon = false;
						}
					}
				}
			} else if (args[0].equalsIgnoreCase("log")) {
				Permission.LOG.handle(sender);
				if (PerformanceMonitor.sendLog) {
					PerformanceMonitor.sendLog = false;
					sender.sendMessage("Server stats are no longer logged to file.");
				} else {
					PerformanceMonitor.sendLog = true;
					sender.sendMessage("Server stats are now logged to file.");
					sender.sendMessage("To stop logging, perform this command again.");
				}
			} else if (args[0].equalsIgnoreCase("clearlog")) {
				Permission.CLEARLOG.handle(sender);
				if (PerformanceMonitor.clearLog()) {
					sender.sendMessage("Server log cleared");
				} else {
					sender.sendMessage("Failed to clear the server log");
				}
			} else if (args[0].equalsIgnoreCase("mem") || args[0].equalsIgnoreCase("memory")) {
				if (sender instanceof Player) {
					Permission.SHOWMEMORY.handle(sender);
					sender.sendMessage(ChatColor.GREEN + "[Static memory] " + ChatColor.YELLOW + "[Dynamic memory] " + ChatColor.RED + "[Unused memory]");
				}
				sender.sendMessage(PerformanceMonitor.getMemory(sender instanceof Player));
			} else if (args[0].equalsIgnoreCase("lagmem") || args[0].equalsIgnoreCase("memlag")) {
				if (sender instanceof Player) {
					Permission.SHOWTICKRATE.handle(sender);
					Permission.SHOWMEMORY.handle(sender);
					sender.sendMessage(ChatColor.GREEN + "[Static memory] " + ChatColor.YELLOW + "[Dynamic memory] " + ChatColor.RED + "[Unused memory]");
				}
				sender.sendMessage(PerformanceMonitor.getMemory(sender instanceof Player));
				sender.sendMessage(PerformanceMonitor.getTPS(sender instanceof Player));
			} else if (args[0].equalsIgnoreCase("ver") || args[0].equalsIgnoreCase("version")) {
				sender.sendMessage("NoLaggMonitor version " + NoLaggMonitor.plugin.getDescription().getVersion());
			} else {
				return false;
			}
		} else {
			Permission.SHOWTICKRATE.handle(sender);
			sender.sendMessage(PerformanceMonitor.getTPS(sender instanceof Player));
		}
		return true;
	}

}
